/* ITALIANO.CMD: Installa MEMSIZE in Italiano. */

'@Echo Off'
'CHCP 850'

/* Carica REXXUTIL. */

Call RxFuncAdd 'SysLoadFuncs', 'REXXUTIL', 'SysLoadFuncs'
Call SysLoadFuncs


/* Inizializza. */

Signal On Failure Name FAILURE
Signal On Halt Name HALT
Signal On Syntax Name SYNTAX

Call SysCls
Say 'Si sta installando MEMSIZE...'
Say ''


/* Verifica l'esistenza dei vari file componenti il programma. */

Language = 'Italiano'

Result = SysFileTree( 'MEMSIZE.EXE', 'Files', 'F' )
If Files.0 = 0 Then
  Do
  Say 'ERRORE: MEMSIZE.EXE non trovato!'
  Signal DONE
  End

Result = SysFileTree( Language".DLL", 'Files', 'F' )
If Files.0 = 0 Then
  Do
  Say 'ERRORE: 'Language'.DLL non trovato!'
  Signal DONE
  End

Result = SysFileTree( Language".HLP", 'Files', 'F' )
If Files.0 = 0 Then
  Do
  Say 'ERRORE: 'Language'.HLP non trovato!'
  Signal DONE
  End

/* Richiede il nome della directory di installazione. */

Say 'Inserire il nome completo della directory in cui '
Say 'si vuole installare MEMSIZE (default C:\OS2\APPS): '
Parse Pull Directory
If Directory = "" Then Directory = 'C:\OS2\APPS'


/* Crea la directory se necessario. */

Result = SysFileTree( Directory, 'Dirs', 'D' )
If Dirs.0 = 0 Then
  Do
  Result = SysMkDir( Directory )
  if Result == 0 Then
    Do
    End
  Else
    Do
    Say 'ERRORE: Impossibile creare la directory di destinazione.'
    Signal DONE
    End
  End
Say ''


/* Richiede la cartella di destinazione. */

Say 'Si vuole installare il programma nella cartella di avvio? (S/N)'
Pull YesNo
If YesNo = "S" Then
  Do
  Folder = '<WP_START>'
  Say "L'oggetto sar posto nella cartella di avvio."
  End
Else
  Do
  Folder = '<WP_DESKTOP>'
  Say "L'oggetto sar posto sulla scrivania."
  End
Say ''


/* Destrugge il vecchio oggetto, se presente. */

Call SysDestroyObject( '<MEMSIZE>' )
Call SysSleep( 5 )


/* Completamento installazione. */

Say 'Si sta copiando MEMSIZE in ' Directory '...'
Copy MEMSIZE.EXE Directory                  '1>NUL'
Copy Language".DLL" Directory"\MEMSIZE.DLL" '1>NUL'
Copy Language".HLP" Directory"\MEMSIZE.HLP" '1>NUL'
Copy Language".DOC" Directory"\MEMSIZE.DOC" '1>NUL'

Result = SysFileTree( "HLP2INF.EXE", 'Files', 'F' )
If Files.0 > 0 Then
   Do
   Result = SysFileTree( Directory"\MEMSIZE.INF", 'Files', 'F' )
   If Files.0 > 0 Then
      Do
      "Erase" Directory"\MEMSIZE.INF"
      End
   "HLP2INF" Directory"\MEMSIZE.HLP"
   End

Result = SysFileTree( "SNAPSHOT.EXE", 'Files', 'F' )
If Files.0 > 0 Then
   Do
   Copy "SNAPSHOT.EXE" Directory"\SNAPSHOT.EXE"  '1>NUL'
   End

Say 'Si sta creando il programma oggetto...'
Type = 'WPProgram'
Title = 'Risorse di Sistema'
Parms = 'OPEN=DEFAULT;MINWIN=DESKTOP;PROGTYPE=PM;EXENAME='Directory'\MEMSIZE.EXE;STARTUPDIR='Directory';OBJECTID=<MEMSIZE>;NOPRINT=YES;'
Result = SysCreateObject( Type, Title, Folder, Parms, 'ReplaceIfExists' )

If Result = 1 Then
  Say 'Oggetto creato!  Fine.'
Else
  Say 'ERRORE: Oggetto non creato.'

Signal DONE

FAILURE:
Say 'REXX fallimento.'
Signal DONE

HALT:
Say 'REXX alt.'
Signal DONE

SYNTAX:
Say 'REXX errore di sintassi.'
Signal DONE

DONE:
Exit
