


pico(1)                                                   pico(1)


Name
       pico  -  simple  text editor in the style of the Pine Com-
       poser

Syntax
       pico [-f] [+n] [-nn] [-t] [-v] [-w] [-z] [file]

Description
       Pico is a simple, display-oriented text  editor  based  on
       the  Pine message system composer.  As with Pine, commands
       are displayed at the bottom of the  screen,  and  context-
       sensitive  help is provided.  As characters are typed they
       are immediately inserted into the text.  Editing  commands
       are  entered  using  control-key combinations.  As a work-
       around for communications programs  that  swallow  certain
       control  characters,  you  can  emulate  a  control key by
       pressing ESCAPE twice, followed  by  the  desired  control
       character,  e.g. "ESC ESC c" would be equivalent to enter-
       ing a ctrl-c.  The editor has five basic  features:  para-
       graph   justification,   searching,   block  cut/paste,  a
       spelling checker, and a file browser.

       Paragraph justification (or filling) takes  place  in  the
       paragraph  that  contains the cursor, or, if the cursor is
       between lines, in the paragraph immediately below.   Para-
       graphs are delimited by blank lines, or by lines beginning
       with a space or tab.  Unjustification can be done  immedi-
       ately after justification using the control-U key combina-
       tion.

       String searches are  not  sensitive  to  case.   A  search
       begins at the current cursor position and wraps around the
       end of the text.  The most recent search string is offered
       as the default in subsequent searches.

       Blocks  of  text can be moved, copied or deleted with cre-
       ative use  of  the  command  for  mark  (ctrl-underscore),
       delete (ctrl-k) and undelete (ctrl-u).  The delete command
       will remove text between the "mark" and the current cursor
       position,  and place it in the "cut" buffer.  The undelete
       command effects a "paste" at the current cursor  position.

       The spell checker examines all words in the text.  It then
       offers, in turn, each misspelled word for correction while
       highlighting  it  in the text.  Spell checking can be can-
       celled at any time.  Alternatively, pico  will  substitute
       for  the  default spell checking routine a routine defined
       by the SPELL environment variable.  The  replacement  rou-
       tine should read standard input and write standard output.

       The file browser is offered as  an  option  in  the  "Read
       File"  and "Write Out" command prompts.  It is intended to
       help in searching for specific files and navigating direc-
       tory  hierarchies.   Filenames  with  sizes  and  names of



                           Version 2.4                          1





pico(1)                                                   pico(1)


       directories in the current working directory are presented
       for selection.  The current working directory is displayed
       on the top line of the display while the list of available
       commands  takes  up  the  bottom  two.  Several basic file
       manipulation  functions  are  supported:   file  renaming,
       copying, and deletion.

       More specific help is available in pico's online help.

Options
       -f     Use  function  keys for commands.  This option sup-
              ported only in conjunction with  UW  Enhanced  NCSA
              telnet.

       +n     Causes pico to be started with the cursor located n
              lines into the file. (Note: no  space  between  "+"
              sign and number)

       -nn    The  -nn option enables new mail notification.  The
              n argument is optional, and specifies how often, in
              seconds, your mailbox is checked for new mail.  For
              example, -n60 causes pico to  check  for  new  mail
              once  every  minute.   The  default interval is 180
              seconds, while the minimum allowed is 30. (Note: no
              space between "n" and the number)

       -t     Enable "tool" mode.  Intended for when pico is used
              as  the  editor  within  other  tools  (e.g.,  Elm,
              Pnews).  Pico will not prompt for save on exit, and
              will not rename the buffer during the  "Write  Out"
              command.

       -v     View the file only, disallowing any editing.

       -w     Disable  word  wrap  (thus  allow  editing  of long
              lines).

       -z     Enable ^Z suspension of pico.

       Lastly,  when  a  running  pico  is  disconnected   (i.e.,
       receives  a  SIGHUP),  pico  will save the current work if
       needed before exiting.  Work is saved  under  the  current
       filename  with  ".save"  appended.  If the current work is
       unnamed, it is saved under the filename "pico.save".


Bugs
       The manner in which lines longer than  the  display  width
       are dealt is not immediately obvious.  Lines that continue
       beyond the edge of the display  are  indicated  by  a  '$'
       character at the end of the line.  Long lines are scrolled
       horizontally as the cursor moves through them.





                           Version 2.4                          2





pico(1)                                                   pico(1)


Files
       pico.save        Unnamed interrupted work saved here.
       *.save           Interrupted work on a named file is saved here.

Authors
       Michael Seibel, mikes@cac.washington.edu
       Laurence Lundblade, lgl@cac.washington.edu
       Pico was originally derived from MicroEmacs 3.6,  by  Dave
       G. Conroy.
       Pico is a trademark of the University of Washington.
       Copyright 1989-1994 by the University of Washington.

See Also
       pine(1)
       Source distribution (part of the Pine Message System):
          ftp://ftp.cac.washington.edu/mail/pine.tar.Z









































                           Version 2.4                          3


