;;
;; Sample startup file for GNU Emacs under emx
;;

;;
;; Enable 8-bit input.  set-input-mode must be called when running
;; Emacs -- calling it before dumping doesn't work.
;;
(set-input-mode nil nil 1)

;;
;; Specify additional frame parameters.
;;
(setq default-frame-alist
      (append '((altgr-modifier . meta) ; AltGr (and AltCar) generate M-
                (shortcuts . (alt-f4))  ; Disable all shortcuts but Alt+F4
                (menu-font . "8.Helv")) ; Use small font for menus
              default-frame-alist))     

;;
;; Display characters 128 through 254 as-is.  Without this
;; statement, octal notation is used for these characters.
;;
(standard-display-8bit 128 254)

;; Use special symbols (which are not displayed as-is when occurring
;; in a buffer) for truncated screen lines, continued lines, for
;; displaying control characters, and for separating side-by-side
;; windows.
;;
(set-display-table-slot standard-display-table 'truncation      16)
(set-display-table-slot standard-display-table 'wrap            31)
(set-display-table-slot standard-display-table 'control         24)
(set-display-table-slot standard-display-table 'vertical-border 186)

;;
;; Raise frame to the foreground if emacsclient requests a buffer.
;;
(add-hook 'server-request-hook
          '(lambda ()
             (make-frame-visible)
             (focus-frame (selected-frame))))

;;
;; Enable OS/2 on-line help.
;;
(autoload 'os2help "os2help" "OS/2 on-line help" t)
(setq os2help "/emx/book/emxdoc.ndx")
(global-set-key [C-f1] 'os2help)

;;
;; Call pm-edit-menu to let the Cut, Copy and Paste choices of the
;; Edit menu use the OS/2 clipboard.
;;
;; Call pm-files-menu to let the `Open File...' and `Save Buffer As...'
;; choices from the Files menu use OS/2's standard file dialog.
;;
;; Call remove-from-window-list to remove emacs.exe (the VIO window)
;; from the Window List.  You might want to uncomment that statement
;; if you use the PM interface and don't run Emacs manually.
;;
;; Call pm-session-bond to establish a bond between emacs.exe (the VIO
;; window) and pmemacs.exe (the PM windows).  If you select emacs.exe,
;; for instance by using the Window List, one of the PM windows will
;; be selected instead of emacs.exe.
;;
;; Set the foreground and background colors of the mode line.
;;
;; Use `bold' face instead of `bold-italic' face for info nodes.
;;
(if window-system
    (progn
      (pm-edit-menu)
      (pm-files-menu)
      ;;(remove-from-window-list)
      (pm-session-bond t)
      (set-face-background 'modeline "red")
      (set-face-foreground 'modeline "yellow")
      (make-face 'info-node)
      (copy-face 'bold 'info-node)))

;; End of site-start.el
